﻿Imports System
Imports System.IO
Imports System.Windows.Forms
Imports NXOpen

Public Class part_props_from_file
	Inherits System.Windows.Forms.Form

	Dim sess As Session = Session.GetSession
	Dim wp As Part = sess.Parts.Work
	Dim undomark As Session.UndoMarkId
	Dim line As String = ""

	Public Shared Sub Main()
		Application.Run(New part_props_from_file)
	End Sub

	Private Sub New()
		MyBase.new()
		Me.InitializeComponent()
	End Sub

	Private Sub baseform_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
		Me.Text = Me.Name
		If wp Is Nothing Then
			lst_log.Items.Add("No Work Part")
			btn_ok.Enabled = False
			Exit Sub
		End If
		undomark = sess.SetUndoMark(Session.MarkVisibility.Visible, Me.Name)
		Dim res As DialogResult = dlg_open.ShowDialog
		If res = Windows.Forms.DialogResult.OK Then
			display_attr()
		End If
	End Sub

	Sub display_attr()
		Dim fs As New FileStream(dlg_open.FileName, FileMode.Open, FileAccess.Read)
		Dim sr As New StreamReader(fs)

		Do
			line = sr.ReadLine
			If line Is Nothing Then Exit Do
			If Not line.StartsWith("#") AndAlso line.Length > 0 Then
				Dim wrds() As String = get_name_and_value(line)
				If wrds.Length > 1 Then
					lst_log.Items.Add(wrds(0).PadRight(20) & wrds(1))
				End If
			End If
		Loop

		sr.Close()
		fs.Close()
	End Sub

	Function get_name_and_value(ByVal line As String) As String()
		Dim wrds() As String = line.Split()
		Dim nv(wrds.Length - 1) As String
		Dim n As Integer
		For Each wrd As String In wrds
			If wrd.Length > 0 Then
				nv(n) = wrd
				n += 1
			End If
		Next wrd
		ReDim Preserve nv(1)
		Return nv
	End Function

	Private Sub btn_ok_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_ok.Click
		For Each line In lst_log.Items
			Dim wrds() As String = get_name_and_value(line)

			wp.SetAttribute(wrds(0), wrds(1))
		Next
		btn_exit.PerformClick()
	End Sub

	Private Sub btn_exit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_exit.Click
		sess.UpdateManager.DoUpdate(undomark)
		Me.Close()
	End Sub

	Public Function GetUnloadOption(ByVal dummy As String) As Integer
		GetUnloadOption = NXOpen.Session.LibraryUnloadOption.Immediately
	End Function

#Region "VS Designer Code"
	
	'Wird vom Windows Form-Designer benötigt.
	Private components As System.ComponentModel.IContainer

	Friend WithEvents btn_exit As System.Windows.Forms.Button
	Friend WithEvents dlg_open As System.Windows.Forms.OpenFileDialog
	Friend WithEvents lst_log As System.Windows.Forms.ListBox
	Friend WithEvents btn_ok As System.Windows.Forms.Button

	'Hinweis: Die folgende Prozedur ist für den Windows Form-Designer erforderlich.
	'Das Bearbeiten ist mit dem Windows Form-Designer möglich.  
	'Das Bearbeiten mit dem Code-Editor ist nicht möglich.
	<System.Diagnostics.DebuggerStepThrough()> _
	Private Sub InitializeComponent()
		Me.btn_exit = New System.Windows.Forms.Button
		Me.dlg_open = New System.Windows.Forms.OpenFileDialog
		Me.lst_log = New System.Windows.Forms.ListBox
		Me.btn_ok = New System.Windows.Forms.Button
		Me.SuspendLayout()
		'
		'btn_exit
		'
		Me.btn_exit.Anchor = CType((System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
		Me.btn_exit.Location = New System.Drawing.Point(161, 323)
		Me.btn_exit.Name = "btn_exit"
		Me.btn_exit.Size = New System.Drawing.Size(83, 23)
		Me.btn_exit.TabIndex = 0
		Me.btn_exit.Text = "Exit"
		'
		'dlg_open
		'
		Me.dlg_open.Filter = "Text Files *.txt|*.txt|All Files *.*|*.*"
		Me.dlg_open.Title = "Open Text File"
		'
		'lst_log
		'
		Me.lst_log.Anchor = CType((((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Bottom) _
					Or System.Windows.Forms.AnchorStyles.Left) _
					Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
		Me.lst_log.Font = New System.Drawing.Font("Arial", 9.0!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
		Me.lst_log.ItemHeight = 15
		Me.lst_log.Location = New System.Drawing.Point(1, 1)
		Me.lst_log.Name = "lst_log"
		Me.lst_log.Size = New System.Drawing.Size(243, 304)
		Me.lst_log.TabIndex = 11
		'
		'btn_ok
		'
		Me.btn_ok.Anchor = CType((System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Left), System.Windows.Forms.AnchorStyles)
		Me.btn_ok.Location = New System.Drawing.Point(1, 323)
		Me.btn_ok.Name = "btn_ok"
		Me.btn_ok.Size = New System.Drawing.Size(83, 23)
		Me.btn_ok.TabIndex = 12
		Me.btn_ok.Text = "OK"
		'
		'part_props_from_file
		'
		Me.ClientSize = New System.Drawing.Size(245, 348)
		Me.Controls.Add(Me.btn_ok)
		Me.Controls.Add(Me.lst_log)
		Me.Controls.Add(Me.btn_exit)
		Me.Name = "part_props_from_file"
		Me.Text = "Base Form"
		Me.TopMost = True
		Me.ResumeLayout(False)

	End Sub
#End Region

End Class
